<?php
/**
 * Created by PhpStorm.
 * User: paulopimenta
 * Date: 10/11/2014
 * Time: 12:15
 */

namespace Fiscal\Logic\Parametros;


use Geral\Entities\Paramfilial;
use Geral\Util\Ambiente;
use Geral\Util\DateUtil;
use Indeterminado\Entities\Grfisimpieclie;
use Indeterminado\Entities\Grfisimpieforn;
use Indeterminado\Entities\Grupofiscimpfil;
use Setforms2\Shared\Registry;

class ParametrosGrupoFiscal {
    public static function updateImpostoFilil($imposto, $filial, $grupoFiscal){
        /** @var Grupofiscimpfil $grupofiscimpfil */
        $grupofiscimpfil = Grupofiscimpfil::findOneByCdimpostoAndCdfilialAndNrorg($imposto, $filial, Ambiente::getNrorg());
        if($grupofiscimpfil instanceof Grupofiscimpfil){
            if(empty($grupoFiscal)){
                $grupofiscimpfil->delete();
            }else{
                $grupofiscimpfil->setCdgrupofisc($grupoFiscal);
                $grupofiscimpfil->setNrorgultatu(Ambiente::getNrorg());
                $grupofiscimpfil->setDtultatu(DateUtil::getDataAtual());
                $grupofiscimpfil->setCdoperultatu(Ambiente::getCdOperador());
                $grupofiscimpfil->persist();
            }
        }
        else{
            $grupofiscimpfil = new Grupofiscimpfil();
            $grupofiscimpfil->setCdgrupofisc($grupoFiscal);
            $grupofiscimpfil->setCdfilial($filial);
            $grupofiscimpfil->setCdimposto($imposto);
            $grupofiscimpfil->setNrorg(Ambiente::getNrorg());
            $grupofiscimpfil->setNrorginclusao(Ambiente::getNrorg());
            $grupofiscimpfil->setNrorgultatu(Ambiente::getNrorg());
            $grupofiscimpfil->setDtinclusao(DateUtil::getDataAtual());
            $grupofiscimpfil->setDtultatu(DateUtil::getDataAtual());
            $grupofiscimpfil->setCdoperinclusao(Ambiente::getCdOperador());
            $grupofiscimpfil->setCdoperultatu(Ambiente::getCdOperador());
            $grupofiscimpfil->persist();
        }

        Registry::getEntityManager()->flush();
    }

    public static function updateImpostoFornecedor($imposto, $empresa, $cdinscesta, $cdforneced, $grupoFiscal){
        /** @var Grfisimpieforn $grfisimpieforn */
        $grfisimpieforn = Grfisimpieforn::findOneByCdimpostoAndCdempresaAndCdinscestaAndCdfornecedAndNrorg($imposto, $empresa, $cdinscesta, $cdforneced, Ambiente::getNrorg());
        if ($grfisimpieforn instanceof Grfisimpieforn) {
            if (empty($grupoFiscal)) {
                $grfisimpieforn->delete();
            } else {
                $grfisimpieforn->setCdgrupofisc($grupoFiscal);
                $grfisimpieforn->setNrorgultatu(Ambiente::getNrorg());
                $grfisimpieforn->setDtultatu(DateUtil::getDataAtual());
                $grfisimpieforn->setCdoperultatu(Ambiente::getCdOperador());
                $grfisimpieforn->persist();
            }
        } else {
            $grfisimpieforn = new Grfisimpieforn();
            $grfisimpieforn->setCdimposto($imposto);
            $grfisimpieforn->setCdempresa($empresa);
            $grfisimpieforn->setCdinscesta($cdinscesta);
            $grfisimpieforn->setCdforneced($cdforneced);
            $grfisimpieforn->setCdgrupofisc($grupoFiscal);
            $grfisimpieforn->setNrorg(Ambiente::getNrorg());
            $grfisimpieforn->setNrorginclusao(Ambiente::getNrorg());
            $grfisimpieforn->setNrorgultatu(Ambiente::getNrorg());
            $grfisimpieforn->setDtinclusao(DateUtil::getDataAtual());
            $grfisimpieforn->setDtultatu(DateUtil::getDataAtual());
            $grfisimpieforn->setCdoperinclusao(Ambiente::getCdOperador());
            $grfisimpieforn->setCdoperultatu(Ambiente::getCdOperador());
            $grfisimpieforn->persist();
        }

        Registry::getEntityManager()->flush();
    }

    public static function updateImpostoCliente($imposto, $empresa, $cdinscesta, $cdcliente, $grupoFiscal){
        /** @var Grfisimpieclie $grfisimpieclie */
        $grfisimpieclie = Grfisimpieclie::findOneByCdimpostoAndCdempresaAndCdinscestaAndCdclienteAndNrorg($imposto, $empresa, $cdinscesta, $cdcliente, Ambiente::getNrorg());
        if($grfisimpieclie instanceof Grfisimpieclie){
            if(empty($grupoFiscal)){
                $grfisimpieclie->delete();
            }else{
                $grfisimpieclie->setCdgrupofisc($grupoFiscal);
                $grfisimpieclie->setNrorgultatu(Ambiente::getNrorg());
                $grfisimpieclie->setDtultatu(DateUtil::getDataAtual());
                $grfisimpieclie->setCdoperultatu(Ambiente::getCdOperador());
                $grfisimpieclie->persist();
            }
        }
        else{
            $grfisimpieclie = new Grfisimpieclie();
            $grfisimpieclie->setCdimposto($imposto);
            $grfisimpieclie->setCdempresa($empresa);
            $grfisimpieclie->setCdinscesta($cdinscesta);
            $grfisimpieclie->setCdcliente($cdcliente);
            $grfisimpieclie->setCdgrupofisc($grupoFiscal);
            $grfisimpieclie->setNrorg(Ambiente::getNrorg());
            $grfisimpieclie->setNrorginclusao(Ambiente::getNrorg());
            $grfisimpieclie->setNrorgultatu(Ambiente::getNrorg());
            $grfisimpieclie->setDtinclusao(DateUtil::getDataAtual());
            $grfisimpieclie->setDtultatu(DateUtil::getDataAtual());
            $grfisimpieclie->setCdoperinclusao(Ambiente::getCdOperador());
            $grfisimpieclie->setCdoperultatu(Ambiente::getCdOperador());
            $grfisimpieclie->persist();
        }

        Registry::getEntityManager()->flush();
    }

    public static function updateTipoFaturamento($cdtipofatur_old, $grupoFiscal){
        $tipoFaturamento = Paramfilial::findByCdtipofaturAndNrorg($cdtipofatur_old, Ambiente::getNrorg());

        /** @var $tpFat Paramfilial */
        foreach ($tipoFaturamento as $tpFat) {
            $tpFat->setCdgrupofisc($grupoFiscal);

            $tpFat->setNrorgultatu(Ambiente::getNrorg());
            $tpFat->setCdoperultatu(Ambiente::getCdOperador());
            $tpFat->setDtultatu(DateUtil::getDataAtual());

            $tpFat->persist();

            Registry::getEntityManager()->flush();
        }
    }
} 