/* Sistemas Integrados TECNISA
   Financeiro

Nome: 0000_FINTMP_VALOR_ABSOLUTO

Descrio:
Script temporrio para atualizao dos campos com valor negativo
nas tabelas MOVBANCARIO, ITTRANSFBANC e MOVREAL.

Criao:
29/02/00 - Andr Rodrigo
*/

BEGIN

   UPDATE MOVBANCARIO
   SET VRMOVBANC = ABS(VRMOVBANC)
   WHERE
      (VRMOVBANC < 0);

   UPDATE ITTRANSFBANC
   SET VRMOVITBANC = ABS(VRMOVITBANC)
   WHERE
      (VRMOVITBANC < 0);

   UPDATE MOVREAL
   SET VRMOVREAL = ABS(VRMOVREAL)
   WHERE
      (VRMOVREAL < 0);

   COMMIT;
END;

/

/* Atualiza os novos status dos ajustes */
DECLARE
   V_TOTAL INTEGER;
BEGIN
   SELECT COUNT(*)
   INTO V_TOTAL
   FROM AJBOLREC
   WHERE IDTPAJBOLREC <> '1';

   IF V_TOTAL = 0 THEN
      FOR C_AJBOLR IN (SELECT CDFILIAL, NRLANBOLREC, CDAJUCTREC,
                              IDTPAJBOLREC, IDORIGAJBREC
                       FROM AJBOLREC
                       WHERE
                          IDTPAJBOLREC = '1' AND
                          IDORIGAJBREC IN ('2')) LOOP
         UPDATE AJBOLREC
         SET IDTPAJBOLREC = C_AJBOLR.IDORIGAJBREC,
             IDORIGAJBREC = '1'
         WHERE
            CDFILIAL    = C_AJBOLR.CDFILIAL    AND
            NRLANBOLREC = C_AJBOLR.NRLANBOLREC AND
            CDAJUCTREC  = C_AJBOLR.CDAJUCTREC;
      END LOOP;
      COMMIT;
   END IF;

   SELECT COUNT(*)
   INTO V_TOTAL
   FROM AJBOLPAG
   WHERE IDTPAJBOLPAG <> '1';

   IF V_TOTAL = 0 THEN
      FOR C_AJBOLP IN (SELECT CDFILIAL, NRLANBOLPAG, CDAJUCTPAG,
                              IDTPAJBOLPAG, IDORIGAJBPAG
                       FROM AJBOLPAG
                       WHERE
                          IDTPAJBOLPAG = '1' AND
                          IDORIGAJBPAG IN ('2', '3')) LOOP
         UPDATE AJBOLPAG
         SET IDTPAJBOLPAG = C_AJBOLP.IDORIGAJBPAG,
             IDORIGAJBPAG = '2'
         WHERE
            CDFILIAL    = C_AJBOLP.CDFILIAL    AND
            NRLANBOLPAG = C_AJBOLP.NRLANBOLPAG AND
            CDAJUCTPAG  = C_AJBOLP.CDAJUCTPAG;
      END LOOP;
      COMMIT;
   END IF;
END;
/