<?php
namespace Teknisa\Model\Integracao\Repositories;

use \Teknisa\Model\Integracao\Entities;

class Tablayoutexp extends \Doctrine\ORM\EntityRepository {
    
    public function getTablesLayoutExportation($conditions){
        $query = <<<SQL
        SELECT *
          FROM (SELECT NRSEQTABEXP AS ID, IDATIVO AS ACTIVE, NMTABELABD AS NAME,
                       CDLAYOUTEXP AS LAYOUT_ID, NRORDEXPLAY AS TABLE_ORDER
                  FROM TABLAYOUTEXP)
         WHERE 1 = 1
               $conditions
      ORDER BY TO_NUMBER(TABLE_ORDER)
SQL;

        $resultSet = $this->getEntityManager()->getConnection()->fetchAll($query);
        foreach($resultSet as &$result) {
            $result['TABLE_ORDER'] = intval($result['TABLE_ORDER']);
        }
        return $resultSet;
    }

    /**
     * @param $layoutCode
     * @param $orgId
     * @return array
     */
    public function getTableLayoutExportationByLayoutCodeAndOrgId($layoutCode, $orgId){
        $query = <<<SQL
            SELECT NMTABELABD
              FROM TABLAYOUTEXP
             WHERE NRORG = :NRORG
               AND IDATIVO = :IDATIVO
               AND CDLAYOUTEXP = :CDLAYOUTEXP
             ORDER BY TO_NUMBER(NRORDEXPLAY)
SQL;

        $params = array (
            'NRORG' => $orgId,
            'CDLAYOUTEXP' => $layoutCode,
            'IDATIVO' => Entities\Tablayoutexp::IS_ACTIVE_POSITIVE
        );

        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
}